From 7b8af18231b539378ec4fc432186b551c08a7774 Mon Sep 17 00:00:00 2001
From: Darya Shanina <d.shanina@postgrespro.ru>
Date: Tue, 22 Apr 2025 11:27:01 +0300
Subject: [PATCH v1] [PGPRO-9971] Allocate enough memory with huge
 shared_buffers. Tags: commitfest_hotfix

---
 contrib/pg_prewarm/autoprewarm.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

diff --git a/contrib/pg_prewarm/autoprewarm.c b/contrib/pg_prewarm/autoprewarm.c
index d061731706a..ea5f7bc49c9 100644
--- a/contrib/pg_prewarm/autoprewarm.c
+++ b/contrib/pg_prewarm/autoprewarm.c
@@ -598,7 +598,7 @@ apw_dump_now(bool is_bgworker, bool dump_unlogged)
 	}
 
 	block_info_array =
-		(BlockInfoRecord *) palloc(sizeof(BlockInfoRecord) * NBuffers);
+	(BlockInfoRecord *) palloc_extended((sizeof(BlockInfoRecord) * NBuffers), MCXT_ALLOC_HUGE);
 
 	for (num_blocks = 0, i = 0; i < NBuffers; i++)
 	{
-- 
2.43.0

